import { Project } from "projen";
import { TypeScriptProject, TypeScriptProjectOptions } from "projen/lib/typescript";
export declare enum TargetDependencyProject {
    SELF = "self",
    DEPENDENCIES = "dependencies"
}
export interface TargetDependency {
    readonly target: string;
    readonly projects: TargetDependencyProject;
}
export declare type TargetDependencies = {
    [target: string]: TargetDependency[];
};
export interface NxMonorepoProjectOptions extends TypeScriptProjectOptions {
    /**
     * @default {}
     */
    readonly targetDependencies?: TargetDependencies;
    /**
     * @default []
     */
    readonly nxIgnorePatterns?: string[];
}
/**
 * @pjid nx-monorepo
 */
export declare class NxMonorepoProject extends TypeScriptProject {
    private readonly implicitDependencies;
    constructor(options: NxMonorepoProjectOptions);
    addImplicitDependency(dependent: Project, dependee: Project): void;
    private get subProjects();
    preSynthesize(): void;
    synth(): void;
}
